import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "PipClock.Clock";

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

Turbine.Plugin.Unload = function(self, sender, args)
	Turbine.Shell.WriteLine("Unload Event ... ");
	pipsWindow = nil;
end

player = Turbine.Gameplay.LocalPlayer.GetInstance();
class = player:GetClassAttributes();
fervorPips = Pips();
currentFervor = FervorWindow();

i = 0;
j = 0;
k = 0;

metronome = function()
	if i == 0 then
		fervorPips:Update(i);
		i = 1;
	elseif i == 1 then
		fervorPips:Update(i);
		i = 2;
	elseif i == 2 then
		fervorPips:Update(i);
		i = 3;
	else
		fervorPips:Update(i);
		i = 0;
	end
end

stance = function()	
	if class:GetStance() == 1 then
		if k == 0 then
			timer = Timer();
			AddCallback(timer,"TimeReached",metronome);
			i = 1;
			k = 1;
		elseif k == 1 then
			j = 1;
			k = 0;
		end
	else
		if j == 1 then
			fervorPips:Update(0);
			RemoveCallback(timer,"TimeReached",metronome);
			i = 0;
			j = 0;
			k = 0;
		end
	end
	
end

AddCallback(class,"StanceChanged",stance);

Turbine.Shell.WriteLine("PipClock 1.0");